package cmht.tfm.uoc.diariosalud;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.Toast;

import java.util.Calendar;

public class CalendarioActivity extends Activity {

    private String tYear;
    private String tDay;
    private String tMonth;

    private Calendar cal;
    private int day;
    private int month;
    private int year;
    private DatePicker dpFecha;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        Log.d("--Print: ", "CalendarioActivity.onCreate");
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_calendario);
        //Declaramos los elemtos de la actividad

        // CalendarView calendario = (CalendarView)findViewById(R.id.calendarView_1);
        dpFecha = (DatePicker) findViewById(R.id.datePicker_1);
        Button btCalendario = (Button) findViewById(R.id.btCalendario);

        //Preparamos el campo de Fecha
        cal = Calendar.getInstance();
        day = cal.get(Calendar.DAY_OF_MONTH);
        month = cal.get(Calendar.MONTH);
        year = cal.get(Calendar.YEAR);

        //Listener
        btCalendario.setOnClickListener(new View.OnClickListener() {
            Intent intent;

            /**
             * Called when a view has been clicked.             *
             * @param v The view that was clicked.
             */
            @Override
            public void onClick(View v) {
                Log.d("--Print: ", "CalendarioActivity.onClick");
                String fecha = dpFecha.getDayOfMonth() + "-" + (dpFecha.getMonth() + 1) + "-" + dpFecha.getYear() + "-";
                cal = Calendar.getInstance();
                day = dpFecha.getDayOfMonth();
                //El mes java los alamacena desde 0 por se suma 1
                month = dpFecha.getMonth() + 1;
                year = dpFecha.getYear();
                String actividad = "CalendarioActivity";
                //formateamos los campos
                tDay = day + "";
                while (tDay.length() < 2) {
                    tDay = "0" + tDay;
                }

                tMonth = month + "";
                while (tMonth.length() < 2) {
                    tMonth = "0" + tMonth;
                }
                tYear = year + "";
                if (tYear.length() < 4) {
                    tYear = "0000";
                }
                //   Toast.makeText(getBaseContext(), "Fecha: "+ tDay +"/"+tMonth+"/"+tYear, Toast.LENGTH_SHORT).show();

                Log.d("--Print: ", "CalendarioActivity.onClick " + fecha + ": " + tDay + tMonth + tYear);
                intent = new Intent(CalendarioActivity.this, HoyActivity.class);
                intent.putExtra("dia", tDay + "");
                intent.putExtra("mes", tMonth);
                intent.putExtra("anyo", year + "");
                intent.putExtra("actividad", actividad);
                startActivity(intent);
            }
        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        Log.d("--Print: ", "CalendarioActivity.onCreateOptionsMenu");
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_calendario, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Log.d("--Print: ", "CalendarioActivity.onOptionsItemSelected: " + item);
        Intent intent;
        switch (item.getItemId()) {
            case R.id.home:
                intent = new Intent(CalendarioActivity.this, MainActivity.class);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_hoy:
                intent = new Intent(CalendarioActivity.this, HoyActivity.class);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_calendario:
                //   intent = new Intent(CalendarioActivity.this, CalendarioActivity.class);
                //   startActivity(intent);
                //   finish();
                break;
            case R.id.menu_sintomas:
                intent = new Intent(CalendarioActivity.this, EmailSintomasActivity.class);
                startActivity(intent);
                //finish();
                break;
            // case R.id.guardar:
            //intent = new Intent(CalendarioActivity.this, SintomasActivity.class);
            // startActivity(intent);
            // finish();
            //  break;
            //case R.id.salir:
            //    intent = new Intent(Intent.ACTION_MAIN);
            //finish();
            //    break;
            default:
                break;

        }

        return super.onOptionsItemSelected(item);
    }

}
