package cmht.tfm.uoc.diariosalud;


import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

import java.util.Calendar;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import cmht.tfm.uoc.diariosalud.clases.DataBaseManager;
import cmht.tfm.uoc.diariosalud.clases.SintomaHandler;

public class EmailSintomasActivity extends Activity implements View.OnClickListener {

    private EditText eTxDestinatario;
    private TextView tvFechaDesde;
    private TextView tvFechaHasta;
    private TextView tvInforme;
    private Button btGenerarDatos;
    private Button btEnviarEmail;
    private ImageButton ibtFechaInicio;
    private ImageButton ibtFechaHasta;
    private Calendar cal;
    private int d;
    private int m;
    private int y;
    private String fecha1Bbdd;
    private String fecha2Bbdd;
    private String fecha1;
    private String fecha2;
    private boolean activoHasta = false;
    private boolean activoDesde = false;
    private Context contexto;
    private String informe = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d("--Print: ", "EmailSintomasActivity.onCreate");
        setContentView(R.layout.activity_email_sintomas);
        //Inicializamos los elemtos de la actividad
        eTxDestinatario = (EditText) findViewById(R.id.eTxDestinatario);
        tvFechaDesde = (TextView) findViewById(R.id.tvFechaDesde);
        tvFechaHasta = (TextView) findViewById(R.id.tvFechaHasta);
        tvInforme = (TextView) findViewById(R.id.tvInforme);
        btGenerarDatos = (Button) findViewById(R.id.btGenerarDatos);
        btEnviarEmail = (Button) findViewById(R.id.btEnviarEmail);
        ibtFechaInicio = (ImageButton) findViewById(R.id.ibtFechaInicio);
        ibtFechaHasta = (ImageButton) findViewById(R.id.ibtFechaHasta);

        //Guardamos el contexto
        contexto = EmailSintomasActivity.this.getApplicationContext();
        //Listener
        btGenerarDatos.setOnClickListener(this);
        btEnviarEmail.setOnClickListener(this);
        ibtFechaHasta.setOnClickListener(this);
        ibtFechaInicio.setOnClickListener(this);

        // Declaramos un intent que realizara el envio
        Intent intentSend = new Intent(android.content.Intent.ACTION_SEND);
        // Se va  enviar texto plano
        intentSend.setType("plain/text");

        //Inicializamos el dia actual
        diaActual();

        //inicializamos los campos fecha
        fecha2Bbdd = getFechaBbdd(d, m, y);
        fecha1Bbdd = getFechaBbdd(1, 0, y);
        fecha2 = getFechaPantalla(d, m, y);
        fecha1 = getFechaPantalla(1, 0, y);

        //Inicializamos los datos de pantalla
        tvFechaDesde.setText(fecha1);
        tvFechaHasta.setText(fecha2);
        tvInforme.setText(informe);

        //Guardamos el contexto
        contexto = EmailSintomasActivity.this.getApplicationContext();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        Log.d("--Print: ", "SintomasActivity.onCreateOptionsMenu");
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_email_sintomas, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Log.d("--Print: ", "SintomasActivity.onOptionsItemSelected");
        Intent intent;
        switch (item.getItemId()) {
            case R.id.home:
                intent = new Intent(EmailSintomasActivity.this, MainActivity.class);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_hoy:
                intent = new Intent(EmailSintomasActivity.this, HoyActivity.class);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_calendario:
                intent = new Intent(EmailSintomasActivity.this, CalendarioActivity.class);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_sintomas:
                //intent = new Intent(SintomasActivity.this, SintomasActivity.class);
                //startActivity(intent);
                //finish();
                break;
            //case R.id.salir:
            //intent = new Intent(Intent.ACTION_MAIN);
            //finish();
            //break;
            default:
                break;
        }

        return super.onOptionsItemSelected(item);
    }

    /**
     * Called when a view has been clicked.
     *
     * @param v The view that was clicked.
     */
    @Override

    public void onClick(View v) {
        Log.d("--Print: ", "SintomasActivity.onClick");
        //Apartir del boton que se pulse se ira a una actividad u otra

        switch (v.getId()) {
            case R.id.btGenerarDatos:
                Log.d("--Print: ", "EmailSintomasActivity.btGenerarDatos");
                generarInforme();
                //Intent intencion= new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
                break;
            case R.id.btEnviarEmail:
                Log.d("--Print: ", "EmailSintomasActivity.btEnviarEmail");
                enviarEmail(v);
                break;
            case R.id.ibtFechaInicio:
                Log.d("--Print: ", "EmailSintomasActivity.ibtFechaInicio");
                activoDesde = true;
                showDialog(R.id.ibtFechaInicio);
                // activoHasta=false;
                break;
            case R.id.ibtFechaHasta:
                Log.d("--Print: ", "EmailSintomasActivity.ibtFechaHasta");
                activoHasta = true;
                showDialog(R.id.ibtFechaHasta);
                // eTxFechaHasta.setText(d + "/" + m + "/" + y);
                // activoDesde=false;
                break;
        }
    }

    @Override
    @Deprecated
    protected Dialog onCreateDialog(int id) {
        Log.d("--Print: ", "SintomasActivity.onCreateDialog");
        switch (id) {
            case R.id.ibtFechaInicio:
                diaActual();
                return new DatePickerDialog(this, mDateSetListener, y, m, d);
            case R.id.ibtFechaHasta:
                diaActual();
                return new DatePickerDialog(this, mDateSetListener, y, m, d);
            default:
                return null;
        }
    }

    public void enviarEmail(View v) {
        Log.d("--Print: ", "SintomasActivity.enviarEmail");
        //obtenemos los datos para el envio del correo
        boolean validadoEmail;
        boolean validadoInforme;

        eTxDestinatario = (EditText) findViewById(R.id.eTxDestinatario);
        tvInforme = (TextView) findViewById(R.id.tvInforme);
        //Hay que validae que el destinatario y el informe no estan en blanco.
        validadoEmail = validaEmail(eTxDestinatario.getText().toString());
        validadoInforme = (tvInforme.getText().length() > 0);
        if (validadoInforme) {
            if (validadoEmail) {
                //Utilizamos un intent para enviar el email
                Intent intentEnvio = new Intent(android.content.Intent.ACTION_SEND);

                //Enviamos texto plano
                intentEnvio.setType("plain/text");

                //colocamos los datos para el envio
                intentEnvio.putExtra(android.content.Intent.EXTRA_EMAIL, new String[]{eTxDestinatario.getText().toString()});
                intentEnvio.putExtra(android.content.Intent.EXTRA_SUBJECT, "Mi diario de salud Informe ");
                intentEnvio.putExtra(android.content.Intent.EXTRA_TEXT, tvInforme.getText());

                //iniciamos la actividad
                startActivity(intentEnvio);
            } else {
                AlertDialog.Builder alDialogoEmail = new AlertDialog.Builder(this);
                alDialogoEmail.setTitle(R.string.error1);

                alDialogoEmail.setMessage(R.string.txToastNoEmail);
                alDialogoEmail.setPositiveButton(R.string.txAceptar, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        //  Toast.makeText(getApplicationContext(), R.string.txToastNoEmail, Toast.LENGTH_LONG).show();
                    }
                });

                alDialogoEmail.create();
                alDialogoEmail.show();
            }

        } else {
            //   Toast.makeText(getBaseContext(), R.string.txToastNoInforme , Toast.LENGTH_SHORT).show();
            //Lanzamos un mensaje de error
            AlertDialog.Builder alDialogoInforme = new AlertDialog.Builder(this);
            alDialogoInforme.setTitle(R.string.error);

            alDialogoInforme.setMessage(R.string.txToastNoInforme);
            alDialogoInforme.setPositiveButton(R.string.txAceptar, new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int id) {
                    // Toast.makeText(getApplicationContext(), R.string.txToastNoInforme, Toast.LENGTH_LONG).show();
                }
            });

            alDialogoInforme.create();
            alDialogoInforme.show();
        }

    }

    private DatePickerDialog.OnDateSetListener mDateSetListener = new DatePickerDialog.OnDateSetListener() {

        @Override
        public void onDateSet(DatePicker view, int yearP, int monthP, int dayP) {
            Log.d("--Print: ", "EmailSintomasActivity.onDateSet");
            y = yearP;
            m = monthP;
            d = dayP;

            if (activoDesde) {
                fecha1Bbdd = getFechaBbdd(d, m, y);
                fecha1 = getFechaPantalla(d, m, y);
                // tvFechaDesde.setText(d + "/" + m + "/" + y);
                tvFechaDesde.setText(fecha1);
                activoDesde = false;
                Log.d("--Print: ", "EmailSintomasActivity.onDateSet fecha1Bbdd: " + fecha1Bbdd);
                Log.d("--Print: ", "EmailSintomasActivity.onDateSet fecha1: " + fecha1);
            }
            if (activoHasta) {
                fecha2Bbdd = getFechaBbdd(d, m, y);
                fecha2 = getFechaPantalla(d, m, y);
                tvFechaHasta.setText(fecha2);
                activoHasta = false;
                Log.d("--Print: ", "EmailSintomasActivity.onDateSet fecha2Bbdd: " + fecha2Bbdd);
                Log.d("--Print: ", "EmailSintomasActivity.onDateSet fecha2: " + fecha2);
            }
        }
    };

    private void diaActual() {
        Log.d("--Print: ", "SintomasActivity.diaActual");
        //Inicializamos el dia actual
        cal = Calendar.getInstance();
        d = cal.get(Calendar.DAY_OF_MONTH);
        m = cal.get(Calendar.MONTH);
        y = cal.get(Calendar.YEAR);

    }

    private String getFechaBbdd(int day, int month, int year) {
        Log.d("--Print: ", "SintomasActivity.getFechaBbdd");
        String fecha;
        //debido a que los meses en java comienzan en cero sumamos 1 al mes para obtener el formato deseado
        month = month + 1;
        String tDay = day + "";
        tDay = tDay.trim();
        while (tDay.length() < 2) {
            tDay = "0" + tDay;
        }
        String tMonth = month + "";
        tMonth = tMonth.trim();
        while (tMonth.length() < 2) {
            tMonth = "0" + tMonth;
        }
        String tYear = year + "";
        tYear = tYear.trim();
        if (tYear.length() < 4) {
            tYear = "0000";
        }
        fecha = tYear + "-" + tMonth + "-" + tDay;
        return fecha;
    }

    private String getFechaPantalla(int day, int month, int year) {
        Log.d("--Print: ", "SintomasActivity.getFechaPantalla");
        String fecha;

        //debido a que los meses en java comienzan en cero sumamos 1 al mes para obtener el formato deseado
        month = month + 1;
        String tDay = day + "";
        tDay = tDay.trim();
        while (tDay.length() < 2) {
            tDay = "0" + tDay;
        }
        String tMonth = month + "";
        tMonth = tMonth.trim();
        while (tMonth.length() < 2) {
            tMonth = "0" + tMonth;
        }
        String tYear = year + "";
        tYear = tYear.trim();
        if (tYear.length() < 4) {
            tYear = "0000";
        }

        fecha = tDay + "/" + tMonth + "/" + tYear;
        return fecha;
    }

    private boolean validaEmail(String email) {
        Log.d("--Print: ", "SintomasActivity.validaEmail");
        boolean validado;
        String patronEmail = "^[_A-Za-z0-9-\\+]+(\\.[_A-Za-z0-9-]+)*@"
                + "[A-Za-z0-9-]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$";
        // Compiles the given regular expression into a pattern.
        Pattern pattern = Pattern.compile(patronEmail);

        // Match the given input against this pattern
        Matcher matcher = pattern.matcher(email);
        validado = matcher.matches();
        //if(!validado){
        // Toast.makeText(getBaseContext(), "Email incorrecto: Vuelva a introducirlo " , Toast.LENGTH_SHORT).show();
        // }
        return validado;
    }

    private void generarInforme() {
        Log.d("--Print: ", "SintomasActivity.generarInforme");
        Long f1;
        Long f2;
        //Transformamos las fechas para poder trabajar con ellas y hacer validaciones
        try {
            String f = fecha1Bbdd.replace("-", "");
            f1 = Long.parseLong(f);
            f = fecha2Bbdd.replace("-", "");
            f2 = Long.parseLong(f);
        } catch (Exception E) {
            f1 = 0L;
            f2 = 0L;
        }
        if (f1 > f2) {
            // Toast.makeText(getBaseContext(), R.string.txToastNoFecha, Toast.LENGTH_SHORT).show();
            AlertDialog.Builder alDialogoFecha = new AlertDialog.Builder(this);
            alDialogoFecha.setTitle(R.string.error2);

            alDialogoFecha.setMessage(R.string.txToastNoFecha);
            alDialogoFecha.setPositiveButton(R.string.txAceptar, new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int id) {
                    //   Toast.makeText(getApplicationContext(), R.string.txToastNoFecha, Toast.LENGTH_LONG).show();
                }
            });

            alDialogoFecha.create();
            alDialogoFecha.show();
            informe="";
            tvInforme.setText(informe);
        } else {
            DataBaseManager managerBd = new DataBaseManager(this);
            Cursor c = managerBd.buscarDatosInforme(fecha1Bbdd, fecha2Bbdd);
            SintomaHandler sh = new SintomaHandler();
            informe = sh.gestionSintomas(c, fecha1, fecha2, this);
            tvInforme.setText(informe);
        }
    }

    @Override
    protected void onSaveInstanceState(@NonNull Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putString("INFORME", informe);
        outState.putString("FECHA1", fecha1);
        outState.putString("FECHA2", fecha2);
        outState.putString("FECHABD1", fecha1Bbdd);
        outState.putString("FECHABD2", fecha2Bbdd);
    }

    @Override
    protected void onRestoreInstanceState(@NonNull Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        informe = savedInstanceState.getString("INFORME");
        fecha1 = savedInstanceState.getString("FECHA1");
        fecha2 = savedInstanceState.getString("FECHA2");
        fecha1Bbdd = savedInstanceState.getString("FECHABD1");
        fecha2Bbdd = savedInstanceState.getString("FECHABD2");
        tvInforme.setText(String.valueOf(informe));
        tvFechaDesde.setText(String.valueOf(fecha1));
        tvFechaHasta.setText(String.valueOf(fecha2));
    }

}

