package cmht.tfm.uoc.diariosalud;

import android.app.ActionBar;
import android.app.Activity;
import android.content.Context;

import android.content.Intent;
import android.os.Bundle;

import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.ListAdapter;
import android.widget.Toast;

import cmht.tfm.uoc.diariosalud.clases.IntentHelper;


public class FotosActivity extends Activity {
    //declaramos las imagenes que se van a mostrar
    public Integer[] imagenes = new Integer[]{
            R.mipmap.pic1, R.mipmap.pic2, R.mipmap.pic3,
            R.mipmap.pic4, R.mipmap.pic5, R.mipmap.pic6,
            R.mipmap.pic7, R.mipmap.pic8, R.mipmap.pic9,
            R.mipmap.pic10, R.mipmap.pic11,
            R.mipmap.pic12, R.mipmap.pic13,
            R.mipmap.pic14, R.mipmap.pic15, R.mipmap.pic16,
            R.mipmap.pic17, R.mipmap.pic18
    };
    //declaramos las varibles que necesitamos en la actividad
    private GridView gridViewFotos;
    private IntentHelper myIntentHelper;
    public static final String ACTIVIDAD = "FotosActivity";
    private Intent myIntent;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        Log.d("--Print: ", "FotosActivity.onCreate:");
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_fotos);
        ActionBar actionBar = getActionBar();
        actionBar.hide();
        Log.d("--Print: ", "FotosActivity.actionBar " + actionBar.isShowing());

        gridViewFotos = (GridView) findViewById(R.id.gridViewFotos);
        //declaramos las varibles que necesitamos en la actividad
        gridViewFotos.setAdapter(new ImageAdapter(this));
        myIntent = getIntent();
        Log.d("--Print: ", "getIntent() " + myIntent);
        myIntentHelper = new IntentHelper();
        //myIntentHelper.getMiIntentPropiedades(myIntent) ;
        myIntent = myIntentHelper.getMiIntentPropiedades(myIntent);

        gridViewFotos.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Log.d("--Print: ", "FotosActivity.setOnItemClickListener:");
                //  Toast.makeText(getBaseContext(), "pic" + (position + 1) + " selected", Toast.LENGTH_SHORT).show();
                Intent i = new Intent(FotosActivity.this, HoyActivity.class);
                i = myIntentHelper.setNewIntentWithOldIntent(i, myIntent);
                i = myIntentHelper.setMiIntentFoto(i, position + "", ACTIVIDAD);
                i = myIntentHelper.getMiIntentPropiedades(i);
                //   i.putExtra("posicion", position);
                startActivity(i);
                //finish();
            }

        });
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        //No queremos que se vea el menu en esta pantalla
        // Inflate the menu; this adds items to the action bar if it is present.
        // getMenuInflater().inflate(R.menu.menu_fotos, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public class ImageAdapter extends BaseAdapter {
        private Context context;

        public ImageAdapter(Context c) {
            context = c;
        }

        /**
         * How many items are in the data set represented by this Adapter.
         *
         * @return Count of items.
         * Devuleve el nuemro de imagenes
         */

        @Override
        public int getCount() {
            return imagenes.length;
        }

        /**
         * Get the data item associated with the specified position in the data set.
         *
         * @param position Position of the item whose data we want within the adapter's
         *                 data set.
         * @return The data at the specified position.
         * //nos devuelve el elemento
         */
        @Override
        public Object getItem(int position) {
            return null;
        }

        /**
         * Get the row id associated with the specified position in the list.
         *
         * @param position The position of the item within the adapter's data set whose row id we want.
         * @return The id of the item at the specified position.
         * ////nos devuelve el identificador del elemento
         */
        @Override
        public long getItemId(int position) {
            return 0;
        }

        /**
         * Get a View that displays the data at the specified position in the data set. You can either
         * create a View manually or inflate it from an XML layout file. When the View is inflated, the
         * parent View (GridView, ListView...) will apply default layout parameters unless you use
         * {@link LayoutInflater#inflate(int, ViewGroup, boolean)}
         * to specify a root view and to prevent attachment to the root.
         *
         * @param position    The position of the item within the adapter's data set of the item whose view
         *                    we want.
         * @param convertView The old view to reuse, if possible. Note: You should check that this view
         *                    is non-null and of an appropriate type before using. If it is not possible to convert
         *                    this view to display the correct data, this method can create a new view.
         *                    Heterogeneous lists can specify their number of view types, so that this View is
         *                    always of the right type (see {@link #getViewTypeCount()} and
         *                    {@link #getItemViewType(int)}).
         * @param parent      The parent that this view will eventually be attached to
         * @return A View corresponding to the data at the specified position.
         * //devuelve una vista ImageView
         */
        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            ImageView imagenV = (ImageView) convertView;
            if (convertView == null) {
                imagenV = new ImageView(context);

                imagenV.setLayoutParams(new GridView.LayoutParams(95, 95));
                imagenV.setScaleType(ImageView.ScaleType.CENTER_CROP);
                imagenV.setPadding(5, 5, 5, 5);
            }

            imagenV.setImageResource(imagenes[position]);

            return imagenV;
        }
    }

    @Override
    public void onStop() {
        super.onStop();

    }

}
