package cmht.tfm.uoc.diariosalud;

import android.app.ActionBar;
import android.app.Activity;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.AttributeSet;
import android.util.Log;
import android.view.InflateException;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageSwitcher;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RatingBar;
import android.widget.SimpleCursorAdapter;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;
import android.os.Handler;
import android.database.Cursor;

import java.util.ArrayList;
import java.util.Calendar;

import cmht.tfm.uoc.diariosalud.adaptadores.AdaptadorSintoma;
import cmht.tfm.uoc.diariosalud.adaptadores.AdaptadorSintomas;
import cmht.tfm.uoc.diariosalud.clases.DataBaseHelper;
import cmht.tfm.uoc.diariosalud.clases.DataBaseManager;
import cmht.tfm.uoc.diariosalud.clases.IntentHelper;
import cmht.tfm.uoc.diariosalud.clases.Sintoma;


public class HoyActivity extends Activity implements View.OnClickListener {

    //Declaramos los elemtos de la actividad
    public static final String ACTIVIDAD = "HoyActivity";
    private TextView txHoy;
    private TextView tvSintomas1;
    private EditText tx_1;
    private RatingBar rb_Estrellas;
    private Button btInserImagen;
    private Button btInserSintoma1;
    private ImageView imagen_1;
    private Calendar cal;
    private int day;
    private int month;
    private int year;
    private String sintomasAlmacenar = "";
    private String bundleDay;
    private String bundleMonth;
    private String bundleYear;
    private Integer[] imagenes = new Integer[]{
            R.mipmap.pic1, R.mipmap.pic2, R.mipmap.pic3,
            R.mipmap.pic4, R.mipmap.pic5, R.mipmap.pic6,
            R.mipmap.pic7, R.mipmap.pic8, R.mipmap.pic9,
            R.mipmap.pic10, R.mipmap.pic11,
            R.mipmap.pic12, R.mipmap.pic13,
            R.mipmap.pic14, R.mipmap.pic15, R.mipmap.pic16,
            R.mipmap.pic17, R.mipmap.pic18
    };

    private ArrayList<Sintoma> miSintomas;
    private int numFotoAlmacenar = 99;
    //fecha
    private String fechaBd = null;
    private String fechaPantalla = null;
    //base de datos
    private DataBaseManager managerBd;
    private Cursor cursor;
    SimpleCursorAdapter adapterCursor;
    private String bundleFecha;


    private Intent i;
    private IntentHelper myIntentHelper;
    private Context contexto;

    public static final String TABLE_NAME = "EntradaDiario";
    public static final String COL_ID = "_id";
    public static final String COL_FECHA = "fecha";
    public static final String COL_ESTRELLAS = "estrellas";
    public static final String COL_TEXTO = "texto";
    public static final String COL_IMAGEN = "imagen";
    public static final String COL_SINTOMAS = "sintomas";


    private String bdFecha = "";
    private String bdId = "";
    private String bdEstrella = "";
    private String bdTexto = "";
    private String bdImagen = "";
    private String bdSintomas = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        Log.d("--Print: ", "HoyActivity.onCreate");

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_hoy);

        //Inicializamos los elemtos de la actividad
        tx_1 = (EditText) findViewById(R.id.etx_1);
        rb_Estrellas = (RatingBar) findViewById(R.id.rb_Estrellas);
        btInserImagen = (Button) findViewById(R.id.btInserImagen);
        btInserSintoma1 = (Button) findViewById(R.id.btInsertarSintoma1);
        imagen_1 = (ImageView) findViewById(R.id.imagen_1);
        txHoy = (TextView) findViewById(R.id.tvHoy);
        tvSintomas1 = (TextView) findViewById(R.id.tvSintomas1);
        //Guardamos el contexto
        contexto = HoyActivity.this.getApplicationContext();
        //Listener
        btInserImagen.setOnClickListener(this);
        //Mostramos la actionBar
        ActionBar actionBar = getActionBar();
        actionBar.show();
        //Preparamos los campos

        //Miramos si venimos de otra actividad
        setDatosOtraActividad();

    }

    private void setDatosOtraActividad() {
        Log.d("--Print: ", "HoyActivity.setDatosOtraActividad ");
        i = getIntent();
        Log.d("--Print: ", "Hoyactivity.Miramos si venimos de otra actividad. i: " + i);
        myIntentHelper = new IntentHelper();

        String actividad = myIntentHelper.getActividad(i);

        Log.d("--Print: ", "HoyActivity.setDatosOtraActividad " + actividad);
        switch (actividad) {
            case "MainActivity":
                setDiaActual();
                /* Hay que Buscar en la base de datos si hay algo guardado de hoy */
                /* Hay que Setear la pantalla si hay datos en la base de datos */
                new BuscarTask().execute();
                break;
            case "CalendarioActivity":
                setDiaCalendarioAct(i);
                /*Hay que buscar en la base de datos los datos realacionados con la fecha que llega */
                new BuscarTask().execute();
                break;
            case "HoyActivity":
                setDiaActual();
                 /*Hay que buscar en la base de datos los datos realacionados con la fecha que llega */
                new BuscarTask().execute();
                break;
            case "SintomasActivity":
                //en principio este caso no esta contemplado
                break;
            case "FotosActivity":
                //Seteamos la fecha
                setDiaCalendarioAct(i);
                //Setamos la foto
                setFotoAct(i);
                //setamos las estrellas
                setEstrellasAct(i);
                //setamos el texto
                setTextoAct(i);
                //seteamos los sintomas
                setSintomasAct(i);
                /* Hay que setear la imagen en la pantalla y recuperar todos los datos  asociados*/
                break;
            case "ListViewSintomasActivity":
                //Seteamos la fecha
                setDiaCalendarioAct(i);
                //Setamos la foto
                setFotoAct(i);
                //setamos las estrellas
                setEstrellasAct(i);
                //setamos el texto
                setTextoAct(i);
                //seteamos los sintomas
                setSintomasAct(i);
                /* Hay que setear los sintomas en la pantalla y recuperar todos los datos  asociados*/
                break;
            case "SplashActivity":
                //en principio este caso no esta contemplado
                break;
            default:
                //Se viene desde el menu inicial sin intent (Main activity)
                setDiaActual();
                new BuscarTask().execute();
                //Toast.makeText(getApplicationContext(), "Default: Ha ocurrido un Error se mostrará el día actual...."+actividad , Toast.LENGTH_SHORT).show();
                break;
        }

    }

    public void onClick(View view) {
        Log.d("--Print: ", "HoyActivity.onClick");
        // imagen_1.setImageResource(R.mipmap.prototipo2);
        // Toast.makeText(getBaseContext(), "Pulso el boton de imagen " , Toast.LENGTH_SHORT).show();
        Intent intent;
        intent = getIntent();

        intent = new Intent(HoyActivity.this, FotosActivity.class);
        myIntentHelper.setMiIntentPropiedades(intent, day + "", month + "", year + "", rb_Estrellas.getRating() + "", tx_1.getText() + "", numFotoAlmacenar + "", sintomasAlmacenar + "", ACTIVIDAD);
        startActivity(intent);
        //finish();
    }

    public void onClickSintomas(View view) {
        Intent intent;
        intent = getIntent();
        intent = new Intent(HoyActivity.this, ListViewSintomasActivity.class);
        myIntentHelper.setMiIntentPropiedades(intent, day + "", month + "", year + "", rb_Estrellas.getRating() + "", tx_1.getText() + "", numFotoAlmacenar + "", sintomasAlmacenar + "", ACTIVIDAD);

        startActivity(intent);
        //finish();
    }

    public void eventoInsertarImagen(View view) {
        imagen_1.setImageResource(R.mipmap.prototipo2);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        Log.d("--Print: ", "HoyActivity.onCreateOptionsMenu");
        // Inflate the menu; this adds items to the action bar if it is present.
        MenuInflater mif = getMenuInflater();
        mif.inflate(R.menu.menu_hoy, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Log.d("--Print: ", "HoyActivity.onOptionsItemSelected " + item);
        Intent intent;
        switch (item.getItemId()) {
            case R.id.home:
                intent = new Intent(HoyActivity.this, MainActivity.class);
                setMiIntentPropiedades(intent);
                myIntentHelper.setMiIntentPropiedades(intent, day + "", month + "", year + "", rb_Estrellas.getRating() + "", tx_1.getText() + "", numFotoAlmacenar + "", sintomasAlmacenar + "", ACTIVIDAD);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_hoy:
                intent = new Intent(HoyActivity.this, HoyActivity.class);
                //  myIntentHelper.setMiIntentPropiedades(intent, day+"",month+"", year+"",rb_Estrellas.getRating()+"",tx_1.getText()+"",numFotoAlmacenar+"", ACTIVIDAD);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_calendario:
                intent = new Intent(HoyActivity.this, CalendarioActivity.class);
                //  setMiIntentPropiedades(intent);
                myIntentHelper.setMiIntentPropiedades(intent, day + "", month + "", year + "", rb_Estrellas.getRating() + "", tx_1.getText() + "", numFotoAlmacenar + "", sintomasAlmacenar + "", ACTIVIDAD);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_sintomas:
                intent = new Intent(HoyActivity.this, EmailSintomasActivity.class);
                //setMiIntentPropiedades(intent);
                myIntentHelper.setMiIntentPropiedades(intent, day + "", month + "", year + "", rb_Estrellas.getRating() + "", tx_1.getText() + "", numFotoAlmacenar + "", sintomasAlmacenar + "", ACTIVIDAD);
                startActivity(intent);
                //finish();
                break;
            //case R.id.guardar:
            // Log.d("--Print: ", "Hoyactivity.Menu. " + R.string.guardar);
            // new GuardarTask().execute();
            // guardarBbdd();
            // break;
            // case  R.id.salir:
            // intent = new Intent(HoyActivity.this, SintomasActivity.class);
            // startActivity(intent);
            // Log.d("--Print: ", "Hoyactivity.Menu "+R.string.salir);
            // intent = new Intent (Intent.ACTION_MAIN);
            // finish();
            //   break;
            default:
                break;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onStart() {
        super.onStart();
        Log.d("--Print: ", "HoyActivity.onStart");
    }

    @Override
    public void onRestart() {
        super.onRestart();
        Log.d("--Print: ", "HoyActivity.onRestart");
    }

    @Override
    public void onResume() {
        super.onResume();
        Log.d("--Print: ", "HoyActivity.onResume");
    }

    @Override
    public void onPause() {
        super.onPause();
        Log.d("--Print: ", "HoyActivity.onPause");
    }

    @Override
    public void onStop() {
        super.onStop();
        Log.d("--Print: ", "Hoyactivity.onStop");
        //Guardamos en la base de datos
        String hoyTexto = tx_1.getText() + "";
        String hoyEstrellas = rb_Estrellas.getRating() + "";
        String hoyFotoAlmacenar = numFotoAlmacenar + "";
        String hoySintomas = tvSintomas1.getText() + "";

        long retorno;
        managerBd = new DataBaseManager(this);

        Log.d("--Print: ", "Hoyactivity.onStop ..... Foto fecha,Estrellas,Texto   " + hoyFotoAlmacenar + " " + fechaBd + " " + hoyEstrellas + " " + hoyTexto + "  ");
        retorno = managerBd.insertarComprobandoExitencia(fechaBd, hoyEstrellas, hoyTexto, hoyFotoAlmacenar, hoySintomas);
        if (retorno == -1) {
            Log.d("--Print: ", "Hoyactivity.onStop ..... No se ha podido guardar la entrada");
        }
        managerBd = new DataBaseManager(contexto);
        //Pruebas comprobamos si se ha guardado bien
        Cursor c = managerBd.buscarEntradaDiario(fechaBd);
        Log.d("--Print: ", "Hoyactivity.onStop c.getCount() " + c.getCount());
        if (c != null) {
            Log.d("--Print: ", "Hoyactivity.onStop. " + c);
            int cont = c.getCount();
            if (cont > 0) {
                c.moveToFirst();
                //  while ((!c.isAfterLast()) ){
                while (!c.isAfterLast()) {
                    bdFecha = c.getString(c.getColumnIndex(COL_FECHA));
                    bdId = c.getString(c.getColumnIndex(COL_ID));
                    bdEstrella = c.getString(c.getColumnIndex(COL_ESTRELLAS));
                    bdTexto = c.getString(c.getColumnIndex(COL_TEXTO));
                    bdImagen = c.getString(c.getColumnIndex(COL_IMAGEN));
                    bdSintomas = c.getString(c.getColumnIndex(COL_SINTOMAS));
                    Log.d("--Print: ", ".Hoyactivity.onStop c.getCount().BBDD " + " " + bdId + " " + bdFecha + " " + bdEstrella + " " + bdImagen + " " + bdTexto + " " + bdSintomas);
                    c.moveToNext();
                }
            }
        }
        c.close();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        Log.d("--Print: ", "Hoyactivity.onDestroy");

    }

    public class BuscarTask extends AsyncTask<Void, Void, Void> {
        /**
         * Runs on the UI thread before {@link #doInBackground}.
         *
         * @see #onPostExecute
         * @see #doInBackground
         */
        @Override
        protected void onPreExecute() {
            Log.d("--Print: ", "HoyactivityBuscarTask.onPreExecute");
            //  Toast.makeText(getApplicationContext(), "Buscando....", Toast.LENGTH_SHORT).show();
            managerBd = new DataBaseManager(contexto);
            Log.d("--Print: ", "HoyactivityBuscarTask.onPreExecute fechaBd " + fechaBd);
            try {
                Cursor c = managerBd.buscarEntradaDiario(fechaBd);
                //Cursor c = db.rawQuery("SELECT * FROM EntradaDiario where fecha=\"2010-11-03\"", null);
                Log.d("--Print: ", "Hoyactivity c.getCount() " + c.getCount());
                if (c != null) {
                    Log.d("--Print: ", "Hoyactivity c. " + c);
                    int cont = c.getCount();
                    if (cont > 0) {
                        c.moveToFirst();
                        //  while ((!c.isAfterLast()) ){
                        if (!c.isAfterLast()) {
                            bdFecha = c.getString(c.getColumnIndex(COL_FECHA));
                            bdId = c.getString(c.getColumnIndex(COL_ID));
                            bdEstrella = c.getString(c.getColumnIndex(COL_ESTRELLAS));
                            bdTexto = c.getString(c.getColumnIndex(COL_TEXTO));
                            bdImagen = c.getString(c.getColumnIndex(COL_IMAGEN));
                            bdSintomas = c.getString(c.getColumnIndex(COL_SINTOMAS));
                            Log.d("--Print: ", ".HoyactivityBuscarTask.onPreExecute.BBDD " + " " + bdId + " " + bdFecha + " " + bdEstrella + " " + bdImagen + " " + bdTexto + " " + bdSintomas);
                            c.moveToNext();
                        }
                    } else {
                        bdFecha = fechaBd;
                        bdEstrella = "0";
                        bdTexto = "";
                        bdImagen = "99";
                        bdSintomas = "";
                        Log.d("--Print: ", "HoyactivityBuscarTask.onPreExecute.BBDD: " + " " + bdId + " " + bdFecha + " " + bdEstrella + " " + bdImagen + " " + bdTexto + " " + bdSintomas);

                    }
                    c.close();
                }
                //Pintamos la pantalla Hoy con los datos de la base de datos
                pintarPantalla();


            } catch (Exception E) {
                System.out.println("Print Error Hoyactivity. Base de datos Error: " + E);
            }
        }

        /**
         * <p>Runs on the UI thread after {@link #doInBackground}. The
         * specified result is the value returned by {@link #doInBackground}.</p>
         * <p/>
         * <p>This method won't be invoked if the task was cancelled.</p>
         *
         * @param aVoid The result of the operation computed by {@link #doInBackground}.
         * @see #onPreExecute
         * @see #doInBackground
         * @see #onCancelled(Object)
         */
        @Override
        protected void onPostExecute(Void aVoid) {
            Log.d("--Print: ", "HoyactivityBuscarTask.onPostExecute");
        }

        /**
         * Runs on the UI thread after {@link #publishProgress} is invoked.
         * The specified values are the values passed to {@link #publishProgress}.
         *
         * @param values The values indicating progress.
         * @see #publishProgress
         * @see #doInBackground
         */
        @Override
        protected void onProgressUpdate(Void... values) {
            Log.d("--Print: ", "HoyactivityBuscarTask.onProgressUpdate");
            super.onProgressUpdate(values);
        }

        /**
         * Override this method to perform a computation on a background thread. The
         * specified parameters are the parameters passed to {@link #execute}
         * by the caller of this task.
         * <p/>
         * This method can call {@link #publishProgress} to publish updates
         * on the UI thread.
         *
         * @param params The parameters of the task.
         * @return A result, defined by the subclass of this task.
         * @see #onPreExecute()
         * @see #onPostExecute
         * @see #publishProgress
         */
        @Override
        protected Void doInBackground(Void... params) {
            Log.d("--Print: ", "HoyactivityBuscarTask.onProgressUpdate");
            //20MAyo  comentado pruebas
            //cursor =managerBd.buscarEntradaDiario(fechaBd);
            return null;
        }
    }

    public class GuardarTask extends AsyncTask<Void, Void, Void> {
        /**
         * Runs on the UI thread before {@link #doInBackground}.
         *
         * @see #onPostExecute
         * @see #doInBackground
         */
        @Override
        protected void onPreExecute() {
            Log.d("--Print: ", "Hoyactivity.GuardarTask.onPreExecute");
            guardarBbdd();
        }

        /**
         * <p>Runs on the UI thread after {@link #doInBackground}. The
         * specified result is the value returned by {@link #doInBackground}.</p>
         * <p/>
         * <p>This method won't be invoked if the task was cancelled.</p>
         *
         * @param aVoid The result of the operation computed by {@link #doInBackground}.
         * @see #onPreExecute
         * @see #doInBackground
         * @see #onCancelled(Object)
         */
        @Override
        protected void onPostExecute(Void aVoid) {
            Log.d("--Print: ", "Hoyactivity.RellenarTask.onPostExecute");
        }

        /**
         * Runs on the UI thread after {@link #publishProgress} is invoked.
         * The specified values are the values passed to {@link #publishProgress}.
         *
         * @param values The values indicating progress.
         * @see #publishProgress
         * @see #doInBackground
         */
        @Override
        protected void onProgressUpdate(Void... values) {
            Log.d("--Print: ", "Hoyactivity. RellenarTask.onProgressUpdate");
            super.onProgressUpdate(values);
        }

        /**
         * Override this method to perform a computation on a background thread. The
         * specified parameters are the parameters passed to {@link #execute}
         * by the caller of this task.
         * <p/>
         * This method can call {@link #publishProgress} to publish updates
         * on the UI thread.
         *
         * @param params The parameters of the task.
         * @return A result, defined by the subclass of this task.
         * @see #onPreExecute()
         * @see #onPostExecute
         * @see #publishProgress
         */
        @Override
        protected Void doInBackground(Void... params) {
            Log.d("--Print: ", "Hoyactivity.RellenarTask.onProgressUpdate");
            //Pruebas 20 Mayo 2015
            //  cursor =managerBd.buscarEntradaDiario(fechaBd);
            return null;
        }
    }

    private Intent setMiIntentPropiedades(Intent myIntent) {

        Log.d("--Print: ", "Hoyactivity.setMiIntentPropiedades");
        Log.d("--Print: ", "Hoyactivity.setMiIntentPropiedades" + imagen_1.getId() + numFotoAlmacenar);
        myIntent.putExtra("dia", day + "");
        myIntent.putExtra("mes", month + "");
        myIntent.putExtra("anyo", year + "");
        myIntent.putExtra("estrellas", rb_Estrellas.getRating() + "");
        myIntent.putExtra("texto", tx_1.getText() + "");
        myIntent.putExtra("foto", numFotoAlmacenar + "");
        myIntent.putExtra("sintomas", sintomasAlmacenar + "");
        myIntent.putExtra("actividad", ACTIVIDAD);

        Log.d("--Print: ", "Hoyactivity.setMiIntentPropiedades: " +
                ACTIVIDAD + " " +
                day + " " +
                month + " " +
                year + " " +
                rb_Estrellas.getRating() + " " +
                tx_1.getText() + " " +
                numFotoAlmacenar + " ");

        return myIntent;
    }

    private Intent getMiIntentPropiedades(Intent myIntent) {
        Log.d("--Print: ", "Hoyactivity.getMiIntentPropiedades");

        if (myIntent != null) {
            Bundle bundle = myIntent.getExtras();
            Log.d("--Print: ", "Hoyactivity.getMiIntentPropiedades. bundle: " + bundle);
            if (bundle != null) {
                String dia = bundle.getString("dia");
                String mes = bundle.getString("mes");
                String year = bundle.getString("anyo");
                String estrellas = bundle.getString("estrellas");
                String texto = bundle.getString("texto");
                String foto = bundle.getString("foto");
                String ac = bundle.getString("actividad");

                Log.d("--Print: ", "Hoyactivity.setMiIntentPropiedades: " +
                        ac + " " +
                        dia + " " +
                        mes + " " +
                        year + " " +
                        estrellas + " " +
                        texto + " " +
                        foto + " ");
            }
        }
        return getIntent();
    }

    public void setDiaActual() {
        Log.d("--Print: ", "HoyActivity.setDiaActual ");
        //Preparamos el campo de Fecha actual
        cal = Calendar.getInstance();
        day = cal.get(Calendar.DAY_OF_MONTH);
        month = cal.get(Calendar.MONTH);
        year = cal.get(Calendar.YEAR);
        //debido a que los meses en java comienzan en cero sumamos 1 al mes para obtener el formato deseado
        month = month + 1;
        String tDay = day + "";
        tDay = tDay.trim();
        while (tDay.length() < 2) {
            tDay = "0" + tDay;
        }
        String tMonth = month + "";
        tMonth = tMonth.trim();
        while (tMonth.length() < 2) {
            tMonth = "0" + tMonth;
        }
        String tYear = year + "";
        tYear = tYear.trim();
        if (tYear.length() < 4) {
            tYear = "0000";
        }
        fechaPantalla = tDay + "/" + tMonth + "/" + tYear;
        txHoy.setText(fechaPantalla);
        //base de datos preparamos los datos

        fechaBd = tYear + "-" + tMonth + "-" + tDay;

        Log.d("--Print: ", "HoyActivity.setDiaActual tDay + \"/\" + tMonth + \"/\" + tYear:" + tDay + tMonth + tYear + fechaPantalla);
        Log.d("--Print: ", "HoyActivity.setDiaActual tYear+\"-\"+tMonth+\"-\"+tDay:" + tYear + tMonth + tDay + fechaBd);
    }

    private void setDiaCalendarioAct(Intent intent) {
        Log.d("--Print: ", "HoyActivity.setDiaCalendario ");
        myIntentHelper = new IntentHelper();
        String bDia = myIntentHelper.getDia(i);
        String bMes = myIntentHelper.getMes(i);
        String bYear = myIntentHelper.getYear(i);
        Log.d("--Print: ", "HoyActivity.setDiaCalendario bDia" + bDia + " bMes" + bMes + " bYear" + bYear);
        if ("99".equals(bDia) || "99".equals(bMes) || "99".equals(bYear) || "0000".equals(bYear)) {
            Log.d("--Print: ", "HoyActivity.setDiaCalendario   bDia" + bDia + " bMes" + bMes + " bYear" + bYear);
            Toast.makeText(getApplicationContext(), "Ha ocurrido un Error se mostrará el día actual....", Toast.LENGTH_SHORT).show();
            setDiaActual();
        } else {
            try {
                fechaPantalla = bDia + "/" + bMes + "/" + bYear;
                txHoy.setText(fechaPantalla);
                //base de datos preparamos los datos
                fechaBd = bYear + "-" + bMes + "-" + bDia;
                day = Integer.parseInt(bDia);
                month = Integer.parseInt(bMes);
                year = Integer.parseInt(bYear);
                Log.d("--Print: ", "HoyActivity.setDiaCalendario : " + day + " " + month + " " + year);
                // base de datos preparamos los datos
            } catch (Exception E) {
                Log.d("--Print: ", "HoyActivity.setDiaCalendario Error: " + E);
                Toast.makeText(getApplicationContext(), "Fecha Ha ocurrido un Error se mostrará el día actual....", Toast.LENGTH_SHORT).show();
                setDiaActual();
            }
            ;

        }
        Log.d("--Print: ", "HoyActivity.setDiaCalendario ");
    }

    private void setFotoAct(Intent intent) {
        Log.d("--Print: ", "HoyActivity.setFoto ");
        //Inicializamos la foto que se va a ver
        String foto = myIntentHelper.getFoto(i);
        int numeroFoto = Integer.parseInt(foto);
        Log.d("--Print: ", "HoyActivity.setFoto: " + numeroFoto);
        if (numeroFoto != 99) {
            String nombreFoto = "pic" + numeroFoto;
            numFotoAlmacenar = numeroFoto;
            Log.d("--Print: ", "HoyActivity.setFotoo " + nombreFoto);
            imagen_1.setImageResource(imagenes[numeroFoto]);

        } else {
            numFotoAlmacenar = 99;
            //   imagen_1.setImageResource(imagenes[0]);
        }
    }

    private void setTextoAct(Intent intent) {
        Log.d("--Print: ", "HoyActivity.setTexto ");
        //Inicializamos el texto que se va mostrar
        String texto = myIntentHelper.getTexto(i);
        Log.d("--Print: ", "HoyActivity.setTexto: " + texto);
        tx_1.setText(texto);
    }

    private void setEstrellasAct(Intent intent) {
        Log.d("--Print: ", "HoyActivity.setEstrellas ");
        //Inicializamos el texto que se va mostrar
        String estrellas = myIntentHelper.getEstrellas(i);
        Log.d("--Print: ", "HoyActivity.setEstrellas: " + estrellas);
        Float nEstrella = Float.parseFloat(estrellas);
        rb_Estrellas.setRating(nEstrella);
    }

    private void setSintomasAct(Intent intent) {
        Log.d("--Print: ", "HoyActivity.setSintomas ");
        //Inicializamos el texto que se va mostrar
        String sinto = myIntentHelper.getSintomas(i);
        Log.d("--Print: ", "HoyActivity.setSintomas: " + sinto);
        tvSintomas1.setText(sinto);
        sintomasAlmacenar = sinto;
    }

    private void pintarPantalla() {
        Log.d("--Print: ", "HoyActivity.pintarPantalla ");
        tx_1 = (EditText) findViewById(R.id.etx_1);
        try {
            rb_Estrellas.setRating(Float.parseFloat(bdEstrella));
        } catch (Exception E) {
            rb_Estrellas.setRating(0);
        }
        try {

            int numeroFoto = Integer.parseInt(bdImagen);
            Log.d("--Print: ", "HoyActivity.pintarPantalla bdImagen " + bdImagen + " numeroFoto" + numeroFoto);
            if (numeroFoto != 99) {
                String nombreFoto = "pic" + numeroFoto;
                numFotoAlmacenar = numeroFoto;

                imagen_1.setImageResource(imagenes[numeroFoto]);

            }
        } catch (Exception E) {
            Log.d("--Print: ", "HoyActivity.pintarPantalla Foto Exception " + E);
            numFotoAlmacenar = 99;

        }
        Log.d("--Print: ", "HoyActivity.pintarPantalla bdFecha " + bdFecha);
        Log.d("--Print: ", "HoyActivity.pintarPantalla que utilizo fechaBd " + fechaBd);
        //  txHoy.setText(bdFecha );

        txHoy.setText(fechaPantalla);
        tx_1.setText(bdTexto);
        //  lvsintomas= (ListView) findViewById(R.id.lvSintomas);
        Log.d("--Print: ", "HoyActivity.pintarPantalla bdSintomas " + bdSintomas);
        tvSintomas1.setText(bdSintomas);
        sintomasAlmacenar = bdSintomas;

    }

    private void limpiarPantalla() {
        Log.d("--Print: ", "HoyActivity.limpiarPantalla ");

    }

    public int getnumeroImagen(String imagen) {
        Log.d("--Print: ", "HoyActivity.getnumeroImagen " + imagen);
        int numImagen = 99;
        imagen = imagen.substring(4);
        try {
            numImagen = Integer.parseInt(imagen);
        } catch (Exception E) {
            numImagen = 99;
        }
        Log.d("--Print: ", "HoyActivity.getnumeroImagen " + imagen + " + return " + numImagen);

        return numImagen;
    }

    private void guardarBbdd() {
        Log.d("--Print: ", "Hoyactivity.guardarBbdd");
        //Guardamos en la base de datos
        String hoyTexto = tx_1.getText() + "";
        String hoyEstrellas = rb_Estrellas.getRating() + "";
        String hoyFotoAlmacenar = numFotoAlmacenar + "";
        String hoySintomas = tvSintomas1.getText() + "";

        long retorno;
        // managerBd = new DataBaseManager(contexto);
        Log.d("--Print: ", "Hoyactivity.guardarBbdd ..... Foto fecha,Estrellas,Texto   " + hoyFotoAlmacenar + " " + fechaBd + " " + hoyEstrellas + " " + hoyTexto + "  ");
        retorno = managerBd.insertarComprobandoExitencia(fechaBd, hoyEstrellas, hoyTexto, hoyFotoAlmacenar, hoySintomas);
        if (retorno == -1) {
            Log.d("--Print: ", "Hoyactivity.guardarBbdd ..... No se ha podido guardar la entrada");
        }
        managerBd = new DataBaseManager(contexto);
        //Pruebas comprobamos si se ha guardado bien
        Cursor c = managerBd.buscarEntradaDiario(fechaBd);
        Log.d("--Print: ", "Hoyactivity.guardarBbdd c.getCount() " + c.getCount());
        if (c != null) {
            Log.d("--Print: ", "Hoyactivity.guardarBbdd. " + c);
            int cont = c.getCount();
            if (cont > 0) {
                c.moveToFirst();
                //  while ((!c.isAfterLast()) ){
                while (!c.isAfterLast()) {
                    bdFecha = c.getString(c.getColumnIndex(COL_FECHA));
                    bdId = c.getString(c.getColumnIndex(COL_ID));
                    bdEstrella = c.getString(c.getColumnIndex(COL_ESTRELLAS));
                    bdTexto = c.getString(c.getColumnIndex(COL_TEXTO));
                    bdImagen = c.getString(c.getColumnIndex(COL_IMAGEN));
                    bdSintomas = c.getString(c.getColumnIndex(COL_SINTOMAS));
                    Log.d("--Print: ", ".Hoyactivity.guardarBbdd c.getCount().BBDD " + " " + bdId + " " + bdFecha + " " + bdEstrella + " " + bdImagen + " " + bdTexto + " " + bdSintomas);
                    c.moveToNext();
                }
            }
        }
        c.close();
    }

}

