package cmht.tfm.uoc.diariosalud;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.Toast;

import java.util.Calendar;

public class MainActivity extends Activity implements View.OnClickListener {
    private Calendar cal;
    private int day;
    private int month;
    private int year;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        Log.d("--Print: ", "MainActivity.onCreate");
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        //botones Menu
        Button btHoy = (Button) findViewById(R.id.btHoy);
        Button btCalendario = (Button) findViewById(R.id.btCalendario);
        Button btSintomas = (Button) findViewById(R.id.btSintomas);

        //Seteamos los listener
        btHoy.setOnClickListener(this);
        btCalendario.setOnClickListener(this);
        btSintomas.setOnClickListener(this);

        //Preparamos la fecha
        cal = Calendar.getInstance();
        day = cal.get(Calendar.DAY_OF_MONTH);
        month = cal.get(Calendar.MONTH);
        year = cal.get(Calendar.YEAR);

    }

    public void onClick(View view) {
        Log.d("--Print: ", "MainActivity.onClick");
        //Apartir del boton que se pulse se ira a una actividad u otra
        new miVentanaTask().execute(view.getId());
    }

    private class miVentanaTask extends AsyncTask<Integer, Void, Intent> {
        /**
         * @param params The parameters of the task.
         * @return A result, defined by the subclass of this task.
         * @see #onPreExecute()
         * @see #onPostExecute
         * @see #publishProgress
         */

        @Override
        protected Intent doInBackground(Integer... params) {
            Log.d("--Print: ", "MainActivity.doInBackground");
            Intent i;
            switch (params[0]) {
                case R.id.btHoy:
                    Log.d("--Print: ", "MainActivity.onClickHOY");
                    //Intent intencion= new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
                    i = new Intent(MainActivity.this, HoyActivity.class);
                    startActivity(i);
                    //finish();
                    break;
                case R.id.btCalendario:
                    Log.d("--Print: ", "MainActivity.onClickCALENDARIO");
                    i = new Intent(MainActivity.this, CalendarioActivity.class);
                    startActivity(i);
                    //finish();
                    break;
                case R.id.btSintomas:
                    Log.d("--Print: ", "MainActivity.onClickSINTOMAS");
                    i = new Intent(MainActivity.this, EmailSintomasActivity.class);
                    startActivity(i);
                    //finish();
                    break;
                default:
                    i = new Intent(MainActivity.this, HoyActivity.class);
                    break;
            }
            return i;
        }

        protected void onPostExecute(Intent result) {
            Log.d("--Print: ", "MainActivity.onPostExecute");
            // startActivity(result);
            //  Toast.makeText(getBaseContext(), "Has pulsado " + tipoBoton, Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    @Deprecated
    protected Dialog onCreateDialog(int id) {
        Log.d("--Print: ", "MainActivity.onCreateDialog");
        return new DatePickerDialog(this, datePickerListener, year, month, day);
    }

    private DatePickerDialog.OnDateSetListener datePickerListener = new DatePickerDialog.OnDateSetListener() {

        public void onDateSet(DatePicker view, int selectedYear,
                              int selectedMonth, int selectedDay) {
            Log.d("--Print: ", "MainActivity.onDateSet");
            //Toast.makeText(getBaseContext(), "Has seleccionado "+selectedDay + " / " + (selectedMonth + 1) + " / " + selectedYear, Toast.LENGTH_SHORT).show();
            // et.setText(selectedDay + " / " + (selectedMonth + 1) + " / " + selectedYear);
        }
    };

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        Log.d("--Print: ", "MainActivity.onCreateOptionsMenu");
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        Log.d("--Print: ", "MainActivity.onOptionsItemSelected");
        Intent intent;
        switch (item.getItemId()) {
            case R.id.home:
                //    intent = new Intent(MainActivity.this, MainActivity.class);
                //    startActivity(intent);
                break;
            case R.id.menu_hoy:
                intent = new Intent(MainActivity.this, HoyActivity.class);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_calendario:
                intent = new Intent(MainActivity.this, CalendarioActivity.class);
                startActivity(intent);
                //finish();
                break;
            case R.id.menu_sintomas:
                //  intent = new Intent(MainActivity.this, SintomasActivity.class);
                intent = new Intent(MainActivity.this, EmailSintomasActivity.class);
                startActivity(intent);
                // finish();
                break;
            /* case R.id.guardar:
                intent = new Intent(MainActivity.this, SintomasActivity.class);
                startActivity(intent);
                finish();
                break; */
           /*   case  R.id.salir:
                  //Lanzamos un dialogo para ver si el usuario quiere salir realmente de la aplicacion
                  AlertDialog.Builder alDialogoSalir = new AlertDialog.Builder(this);
                  alDialogoSalir.setTitle(R.string.salir);
                  alDialogoSalir.setIcon(R.drawable.ic_action_back);
                  alDialogoSalir.setMessage(R.string.txConfirmarSalir);
                  alDialogoSalir.setPositiveButton(R.string.txAceptar, new DialogInterface.OnClickListener() {
                      public void onClick(DialogInterface dialog, int id) {
                         Toast.makeText(getApplicationContext(),R.string.txToastCerrarAplicacion, Toast.LENGTH_LONG).show();
                          //finish();
                         // System.exit(0);
                      }
                  });
                  alDialogoSalir.setNegativeButton(R.string.txCancelar, new DialogInterface.OnClickListener() {
                      public void onClick(DialogInterface dialog, int id) {
                       //   Toast.makeText(getApplicationContext(), R.string.salir, Toast.LENGTH_SHORT).show();
                      }
                  });
                  alDialogoSalir.create();
                  alDialogoSalir.show();
            */
            default:
                break;
        }

        return super.onOptionsItemSelected(item);
    }

}
