package cmht.tfm.uoc.diariosalud.adaptadores;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

import java.util.ArrayList;

import cmht.tfm.uoc.diariosalud.R;
import cmht.tfm.uoc.diariosalud.clases.Sintoma;
import cmht.tfm.uoc.diariosalud.HoyActivity;

/**
 * Created by cmht on 06/05/2015.
 */
public class AdaptadorSintoma extends BaseAdapter {

    private ArrayList<Sintoma> sintomas;
    private LayoutInflater inflater;
    private Context context;

    public AdaptadorSintoma(ArrayList<Sintoma> sintomas, Context context) {
        this.sintomas = sintomas;
        this.inflater = LayoutInflater.from(context);
        this.context = context;
    }

    /**
     * How many items are in the data set represented by this Adapter.
     *
     * @return Count of items.
     */
    @Override
    public int getCount() {
        int n = 0;
        if (sintomas != null) {
            Log.d("--Print: ", "AdaptadorSintoma.getCount: " + sintomas.size());
            return sintomas.size();
        } else {
            Log.d("--Print: ", "AdaptadorSintoma.getCount: " + n);
            return n;
        }
    }

    /**
     * Get the data item associated with the specified position in the data set.
     *
     * @param position Position of the item whose data we want within the adapter's
     *                 data set.
     * @return The data at the specified position.
     */
    @Override
    public Object getItem(int position) {
        int n = 0;
        if (sintomas != null) {
            Log.d("--Print: ", "AdaptadorSintoma.getItem: " + sintomas.get(position));
            return sintomas.get(position);
        } else {
            Log.d("--Print: ", "AdaptadorSintoma.getItem: NULL");
            return new Sintoma("vacio", false, -1);
        }
    }

    /**
     * Get the row id associated with the specified position in the list.
     *
     * @param position The position of the item within the adapter's data set whose row id we want.
     * @return The id of the item at the specified position.
     */
    @Override
    public long getItemId(int position) {
        if (sintomas != null) {
            Log.d("--Print: ", "AdaptadorSintoma.getItemId: " + position);
            return position;
        } else {
            Log.d("--Print: ", "AdaptadorSintoma.getItemId: NULL");
            return 0;
        }

    }

    /**
     * Get a View that displays the data at the specified position in the data set. You can either
     * create a View manually or inflate it from an XML layout file. When the View is inflated, the
     * parent View (GridView, ListView...) will apply default layout parameters unless you use
     * {@link LayoutInflater#inflate(int, ViewGroup, boolean)}
     * to specify a root view and to prevent attachment to the root.
     *
     * @param position    The position of the item within the adapter's data set of the item whose view
     *                    we want.
     * @param convertView The old view to reuse, if possible. Note: You should check that this view
     *                    is non-null and of an appropriate type before using. If it is not possible to convert
     *                    this view to display the correct data, this method can create a new view.
     *                    Heterogeneous lists can specify their number of view types, so that this View is
     *                    always of the right type (see {@link #getViewTypeCount()} and
     *                    {@link #getItemViewType(int)}).
     * @param parent      The parent that this view will eventually be attached to
     * @return A View corresponding to the data at the specified position.
     */
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        Log.d("--Print: ", "AdaptadorSintoma.getView");
        // convertView=inflater.inflate(R.layout.activity_hoy, null);
        convertView = inflater.inflate(R.layout.adaptador_listado_sintomas, null);
        Log.d("--Print: ", "AdaptadorSintoma.getView 2                   22222222222");
        Sintoma miSintoma = sintomas.get(position);

        TextView nombre = (TextView) convertView.findViewById(R.id.tvNombreSintoma);
        RadioGroup rgSintomas = (RadioGroup) convertView.findViewById(R.id.rbGroupSintomas);
        RadioButton sintoma1 = (RadioButton) convertView.findViewById(R.id.rbSintoma2);
        RadioButton sintoma2 = (RadioButton) convertView.findViewById(R.id.rbSintoma3);
        RadioButton sintoma3 = (RadioButton) convertView.findViewById(R.id.rbSintoma4);
        CheckBox activo = (CheckBox) convertView.findViewById(R.id.cbSintoma);
        Log.d("--Print: ", "AdaptadorSintoma.getView3                   33333333333");
        int idSintoma = rgSintomas.getCheckedRadioButtonId();
        Log.d("--Print: ", "AdaptadorSintoma.idSintoma: " + idSintoma);

        nombre.setText(miSintoma.getNombre());
        Log.d("--Print: ", "AdaptadorSintoma.getView4                   444444444");
        if (miSintoma.getActivo()) {
            activo.setChecked(true);
        } else {
            activo.setChecked(false);
        }

        int estado = miSintoma.getEstado();
        Log.d("--Print: ", "AdaptadorSintoma.getView5                  55555555 " + estado);
        switch (estado) {
            case 1:
                sintoma1.setChecked(true);
                sintoma2.setChecked(false);
                sintoma3.setChecked(false);
                break;
            case 2:
                sintoma1.setChecked(false);
                sintoma2.setChecked(true);
                sintoma3.setChecked(false);
                break;
            case 3:
                sintoma1.setChecked(false);
                sintoma2.setChecked(false);
                sintoma3.setChecked(true);
                break;
            default:
                sintoma1.setChecked(false);
                sintoma2.setChecked(false);
                sintoma3.setChecked(false);
                break;
        }
        Log.d("--Print: ", "AdaptadorSintoma.getView6                  6666666 " + estado);
        return null;
    }
}
