package cmht.tfm.uoc.diariosalud.clases;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;


/**
 * Created by cmht on 20/04/2015.
 */
public class DataBaseManager {
    public static final String TABLE_NAME = "EntradaDiario";
    public static final String COL_ID ="_id";
    public static final String COL_FECHA ="fecha";
    public static final String COL_ESTRELLAS="estrellas";
    public static final String COL_TEXTO ="texto";
    public static final String COL_IMAGEN="imagen";
    public static final String COL_SINTOMAS="sintomas";

    //String con codigo SQL para Crear la tabla
    public static final String CREATE_TABLE = "create table "
            +TABLE_NAME+ " ( " + COL_ID + " integer primary key autoincrement,"
                              + COL_FECHA + " text not null,"
                              + COL_ESTRELLAS + " text,"
                              + COL_TEXTO + " text,"
                              + COL_IMAGEN + " text,"
                              + COL_SINTOMAS + " text);";

    private DataBaseHelper helper;
    private SQLiteDatabase db;

    public DataBaseManager(Context context){
        Log.d("--Print: ", "DataBaseManager.DataBaseManager");
        helper =new DataBaseHelper(context);
        db = helper.getWritableDatabase();
        Log.d("--Print: ", "DataBaseManager.DataBaseManager db "+db);
    }

    private  ContentValues generarContentValues(String fecha, String estrellas, String texto, String imagen, String sintomas){
        Log.d("--Print: ", "DataBaseManager.generarContentValues");
        ContentValues valores =new ContentValues();
        valores.put(COL_FECHA, fecha);
        valores.put(COL_ESTRELLAS, estrellas);
        valores.put(COL_TEXTO, texto);
        valores.put(COL_IMAGEN,imagen);
        valores.put(COL_SINTOMAS,sintomas);

        return valores;
    }
    public long insertar (String fecha, String estrellas, String texto, String imagen, String sintomas) {
        Log.d("--Print: ", "DataBaseManager.insertar");
        long retorno;
        //Insertar en base de datos
        retorno = db.insert(TABLE_NAME, null, generarContentValues(fecha,estrellas,texto,imagen,sintomas));
        if (retorno == -1) {
            Log.d("--Print: ", "DataBaseManager.insertar. Error al insertar base de datos");
        }
     //   db.close();
        return retorno;
    }
    public long insertarComprobandoExitencia (String fecha, String estrellas, String texto, String imagen, String sintomas) {
        Log.d("--Print: ", "DataBaseManager.insertarComprobandoExitencia");
    //    Log.d("--Print: ", "DataBaseManager.insertarComprobandoExitencia fecha " + fecha + " estrellas " + estrellas + " texto " + texto + " imagen " + imagen);

        long retorno=0;
        String fechabd = "\"" + fecha + "\"";
        //primero busco en la base de datos
        Cursor c = db.rawQuery("SELECT * FROM EntradaDiario where fecha=" + fechabd, null);
        if (c != null) {
            int cont = c.getCount();
            if (cont > 0) {
                //buscar Si el cursor es mayor que 0 hace el update
                //Modificar en base de datos
                retorno =  modificarEntradaDiario(fecha, estrellas, texto, imagen, sintomas);
            } else {
                //buscar Si el cursor es mayor que 0 inserta
                insertar(fecha, estrellas, texto, imagen,sintomas);
            }
        }
       // db.close();
        return retorno;

    }


    public long modificarEntradaDiario (String fecha, String estrellas, String texto, String imagen,String sintomas) {
        Log.d("--Print: ", "DataBaseManager.modificarEntradaDiario fecha ");
     //   Log.d("--Print: ", "DataBaseManager.modificarEntradaDiario fecha "+fecha+ " estrellas "+estrellas+" texto "+texto+" imagen "+imagen);
        long retorno;
          //Modificar en base de datos
        retorno = db.update(TABLE_NAME,generarContentValues(fecha,estrellas,texto,imagen,sintomas),COL_FECHA+"=?",new String[]{fecha});
        if (retorno == -1) {
           Log.d("--Print: ", "DataBaseManager.modificarEntradaDiario.Error al modificar base de datos");
        }
       // db.close();
        return retorno;
    }

    public void eliminar (String fecha) {
        Log.d("--Print: ", "DataBaseManager.eliminar");
        long retorno;
        //Borrar en base de datos
        retorno = db.delete(TABLE_NAME, COL_FECHA + "=?", new String[]{fecha});
        if (retorno == -1) {
            Log.d("--Print: ", "DataBaseManager.eliminar.Error al borrar base de datos");
        }
    }

    public void eliminarMultiple (String fecha1, String fecha2) {
        Log.d("--Print: ", "DataBaseManager.eliminarMultiple");
        long retorno;
        //Borrar en base de datos
        retorno = db.delete(TABLE_NAME, COL_FECHA + "=IN (?,?)", new String[]{fecha1, fecha2});
        if (retorno == -1) {
            Log.d("--Print: ", "DataBaseManager.eliminarMultiple.Error al borrar base de datos");
        }
    }

    public Cursor cargarCursorDatos(){
        Log.d("--Print: ", "DataBaseManager.cargarCursorDatos");
        String [] columnas =new String []{COL_ID ,COL_FECHA,COL_ESTRELLAS,COL_TEXTO,COL_IMAGEN};
        return db.query(TABLE_NAME, columnas,null, null, null, null, null);
    }

    public Cursor buscarEntradaDiario(String fecha){
        Log.d("--Print: ", "DataBaseManager.buscarEntradaDiario fecha "+ fecha);

        String [] columnas =new String []{COL_ID ,COL_FECHA,COL_ESTRELLAS,COL_TEXTO,COL_IMAGEN};
        //return db.query(TABLE_NAME, columnas, COL_FECHA + "=?", new String[]{fecha}, null, null,null);
        String fechabd="\""+fecha+"\"";
        //Log.d("--Print: ", "buscarEntradaDiario "+fechabd);
        Cursor c = db.rawQuery("SELECT * FROM EntradaDiario where fecha="+fechabd, null);
        //db.close();
        return c;
    }
    public Cursor buscarDatosInforme(String fecha1,String fecha2){
       // Select * from tabla where campo_fecha between fecha1 and fecha2
        Log.d("--Print: ", "DataBaseManager.buscarDatosInforme fecha1 "+ fecha1 + " - "+fecha2);
        String [] columnas =new String []{COL_ID ,COL_FECHA,COL_ESTRELLAS,COL_TEXTO,COL_IMAGEN};
        //return db.query(TABLE_NAME, columnas, COL_FECHA + "=?", new String[]{fecha}, null, null,null);
        String fechabd1="\""+fecha1+"\"";
        String fechabd2="\""+fecha2+"\"";
        Cursor c = db.rawQuery("SELECT * FROM EntradaDiario where fecha between "+fechabd1+" and "+fechabd2, null);
        //   db.close();
        return c;
    }
}
