package cmht.tfm.uoc.diariosalud.clases;

/**
 * Created by cmht on 12/05/2015.
 * Clase que modifica el Scrollview generico para que pueda insertarse dentro
 * un ListView
 */

    import android.content.Context;
    import android.util.AttributeSet;
    import android.view.MotionEvent;
    import android.widget.ScrollView;

    public class ListaScrollView extends ScrollView {

        public ListaScrollView(Context context) {
            super(context);
        }

        public ListaScrollView(Context context, AttributeSet attrs) {
            super(context, attrs);
        }

        public ListaScrollView(Context context, AttributeSet attrs, int defStyle) {
            super(context, attrs, defStyle);
        }

        @Override
        public boolean onInterceptTouchEvent(MotionEvent ev) {
            final int action = ev.getAction();
            switch (action) {
                case MotionEvent.ACTION_DOWN:
                    super.onTouchEvent(ev);
                    break;

                case MotionEvent.ACTION_MOVE:
                    return false; // redirect MotionEvents to ourself

                case MotionEvent.ACTION_CANCEL:
                    super.onTouchEvent(ev);
                    break;

                case MotionEvent.ACTION_UP:
                    return false;

                default:
                    break;
            }

            return false;
        }

        @Override
        public boolean onTouchEvent(MotionEvent ev) {
            super.onTouchEvent(ev);
            return true;
        }

    }
